/**
 * LauncherUI.java
 *
 *
 * Created: Mon Jan 28 23:50:43 2002
 *
 * @author <a href="mailto:torutk@alles.or.jp">Toru TAKAHASHI</a>
 * @version
 */
import javax.swing.JPanel;
import javax.swing.Box;
import java.awt.Color;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.util.logging.Logger;
import javax.swing.AbstractAction;
import javax.swing.JTextField;
import java.util.Observable;
import java.util.Observer;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import javax.swing.JButton;

public class LauncherUI extends JPanel implements Observer {
    private JTextField commandField;
    private JButton launchButton;
    private JButton clearButton;
    private Launcher launcher;
    private static String CLASS_NAME = "LauncherUI";
    private static Logger logger = Logger.getLogger(CLASS_NAME);

    public LauncherUI (Launcher aLauncher) {
        setLayout(new BorderLayout());
        launcher = aLauncher;
        launcher.addObserver(this);
        
        Box buttonPanel = Box.createHorizontalBox();
        launchButton = new JButton("Launch");
        launchButton.addActionListener(new AbstractAction() {
                public void actionPerformed(ActionEvent e) {
                    launcher.launch();
                }
            });
        clearButton = new JButton("Clear");
        clearButton.addActionListener(new AbstractAction() {
                public void actionPerformed(ActionEvent e) {
                    launcher.setCommandText("");
                }
            });
        buttonPanel.add(Box.createHorizontalStrut(5));
        buttonPanel.add(launchButton);
        buttonPanel.add(Box.createHorizontalGlue());
        buttonPanel.add(clearButton);
        buttonPanel.add(Box.createHorizontalStrut(5));
        add(buttonPanel, BorderLayout.SOUTH);
        
        commandField = new JTextField(40);
        commandField.setBackground(Color.black);
        commandField.setForeground(Color.white);
        commandField.setCaretColor(Color.white);
        commandField.addFocusListener(new FocusListener() {
                public void focusGained(FocusEvent e) {}
                public void focusLost(FocusEvent e) {
                    logger.finer("ENTRY");
                    String text = commandField.getText();
                    launcher.setCommandText(text);
                }
            });
        commandField.setText(launcher.getCommandText());
        add(commandField, BorderLayout.NORTH);
    }

    /**
     *
     * @param anObservable <description>
     * @param param2 <description>
     */
    public void update(Observable anObservable, Object param2) {
        commandField.setText(launcher.getCommandText());
    }

}// LauncherUI
